#include <stdio.h>
#include <stdlib.h>

typedef struct nodo {
	char caracter;
	int frec;
	struct nodo * izq;
	struct nodo * der;
} NODO;

NODO *crea_nodo( char c, int n )
{
	NODO *paux;

	paux = (NODO *)malloc(sizeof(NODO) );
	if( paux == NULL ) {
		fprintf( stderr, "ERROR: no hay memoria\n" );
		exit(1);
	}
	paux -> caracter = c;
	paux -> frec = n;
	paux -> izq = NULL;
	paux -> der = NULL;

	return paux;
}

void insertar( NODO **Q, NODO *z, int n )
{
	int k, i;
	NODO *ptr;
	int flag;

	k = 0;
	i = 2;

	flag = 0;
	while ( i<n ) {
		ptr = Q[i];
		if( ptr != NULL ) {
			Q[i] = NULL;
			if( z->frec < ptr->frec ){
				while ( Q[k] != NULL )
					k++;
				Q[k] = z;
				flag = 1;
			}	
			while ( Q[k] != NULL )
				k++;
			Q[k] = ptr;
			k++;
			if ( flag == 1 ){
				i++;
				break;
			}
		}
		i++;
	}
	if( flag == 0 ){
		k=0;
		while ( Q[k] != NULL )
			k++;
		Q[k] = z;
	}
	while ( i<n ) {
		ptr = Q[i];
		if( ptr != NULL ) {
			Q[i] = NULL;
			// while ( Q[k] != NULL )
			// 	k++;
			Q[k] = ptr;
			k++;
		}
		i++;
	}
}

void imprime( NODO **Q, int n )
{
	for( int i=0; i<n; i++ )
		if( Q[i] != NULL )
			printf("%d %c %d\n", i, Q[i]->caracter, Q[i]->frec );
	printf("\n");
}

NODO * huffman( NODO *C[], int n )
{
	NODO **Q;
	NODO *pnodo;
	int i;

	Q = (NODO **)malloc(n*sizeof(NODO *) );
	if( Q == NULL ) {
		// Liberar la memoria de C
		fprintf( stderr, "ERROR: no hay memoria\n" );
		exit(2);
	}
	for( i=0; i<n; i++ )
		Q[i] = crea_nodo( C[i]->caracter,  C[i]->frec );

	// Ya tengo la copia de C en Q
	imprime( Q, n );
	
	for( i=0; i < n-1; i++ ) {
		// printf("i=%d\n", i );
		pnodo = crea_nodo( '\0', -1 );
		pnodo -> izq = Q[0];
		pnodo -> der = Q[1];
		Q[0] = Q[1] = NULL;

		pnodo -> frec = (pnodo -> izq) -> frec + (pnodo -> der) -> frec;

		insertar( Q, pnodo, n );
		// imprime( Q, n );
	}
		
	return Q[0];
}


void ordenamiento_por_insercion( NODO *A[], int n )
{
	int i, j;
	NODO key;

	for( j=1; j<n; j++ ){
		key.caracter = A[j]->caracter;
		key.frec = A[j]->frec;
		// Inserta A[j] en la secuencia ordenada A[1..j-1]
		i = j - 1;
		while( i >= 0 && A[i]->frec > key.frec ) {
			A[i+1]->caracter = A[i]->caracter;
			A[i+1]->frec = A[i]->frec;
			i--;
		}
		A[i+1]->caracter = key.caracter;
		A[i+1]->frec = key.frec;
	}
}

void recorrer_en_orden( NODO * pnodo )
{
    if( pnodo != NULL ) {
        recorrer_en_orden( pnodo->izq );
        printf("%c: %d\n", pnodo->caracter, pnodo -> frec );
        recorrer_en_orden( pnodo->der );
    }
}

int main( )
{
	NODO *C[6];
	NODO *arbol;

	C[0] = crea_nodo( 'd', 16 );
	C[1] = crea_nodo( 'a', 45 );
	C[2] = crea_nodo( 'f',  5 );
	C[3] = crea_nodo( 'e',  9 );
	C[4] = crea_nodo( 'c', 12 );
	C[5] = crea_nodo( 'b', 13 );

	ordenamiento_por_insercion( C, 6 );

	arbol = huffman( C, 6 );
	recorrer_en_orden( arbol );

	return 0;
}
